<?php

define('IS_LINUX_OS', true); // Put to false when testing on Windows
define('IS_PI_DEBIAN_OS', false); // Put to false when testing on Windows

define('PRODUCT_NAME', 'mnc');
//define('PRODUCT_CODE', '500810');
define('PRODUCT_CODE', '500811');

define('SQL_SERVER_NAME', 'localhost');
define('SQL_USER_NAME', 'root');
define('SQL_USER_PASSWORD', '');
define('SQL_DB_NAME', 'muxlabnetworkcontroller_dev_db');

define('MESSAGE_SUCCESS', 'Your have updated the software successfuly !');

class Logger{   

	// define log file
	private $log_file = 'MuxlabController_logfile';
	// define file pointer
	
	private $fp = null;
	// write message to the log file
	
	private $enabled = null;
	
	private static $instance;
	
	public function lwrite($message){
		if ($this->enabled == TRUE){
			// if file pointer doesn't exist, then open log file
			if (!$this->fp) $this->lopen();
			// define script name
			$script_name = pathinfo($_SERVER['PHP_SELF'], PATHINFO_FILENAME);
			// define current time
			$time = date('H:i:s');
			// write current time, script name and message to the log file
			fwrite($this->fp, "$time ($script_name) $message\n");
		}
	}
  

  private function __construct(){
  	$this->enabled = TRUE;
  }

  public function enableLogger() {
  	$this->enabled = TRUE;
  }
  
  public function disableLogger() {
  	$this->enabled = FALSE;
  }
  
  public static function getInstance() {
    	if (!isset(self::$instance)) {
    		//$c = __CLASS__;
    		//self::$instance = new $c;
    		self::$instance = new Logger();
    	}
    	return self::$instance;
    }
    
  // open log file   
  private function lopen(){   
    // define log file path and name   
    $lfile = $this->log_file;   
    // define the current date (it will be appended to the log file name)   
    $today = date('Y-m-d');   
    // open log file for writing only; place the file pointer at the end of the file   
    // if the file does not exist, attempt to create it   
    //$this->fp = fopen($lfile . '_' . $today, 'a') or exit("Can't open $lfile!");   
    $this->fp = fopen($_SERVER['DOCUMENT_ROOT'] ."/mnc/" .$lfile . '_' . $today .'.log', 'a') or exit("Can't open $lfile!");
  }

  // open log file
  public function lclose()
  {
      if ($this->fp)
      {
          fclose($this->fp);
      } 
          
  }
  
}

function startsWith($haystack,$needle,$case=false) 
{
    if($case)
    {
        return (strcmp(substr($haystack, 0, strlen($needle)),$needle)===0);
    }
    return (strcasecmp(substr($haystack, 0, strlen($needle)),$needle)===0);
}

function rmdir_recursive($dir,  $dirToNotRemove = "") {
    
    foreach(scandir($dir) as $file) 
    {
       if ('.' === $file || '..' === $file) 
           continue;
       
       if (startsWith($file, "xSoftwareUpdate"))
           continue;
       
       if (is_dir("$dir/$file")) 
           rmdir_recursive("$dir/$file", $dirToNotRemove);
       else 
           unlink("$dir/$file");
   }
 
   if (strpos($dir, "xSoftwareUpdate") == false)
   {
       if ($dir != $dirToNotRemove)
        rmdir($dir);
   }
}

function rmdir_All_recursive($dir) {

    foreach(scandir($dir) as $file)
    {
        if ('.' === $file || '..' === $file)
            continue;
         
        if (is_dir("$dir/$file"))
            rmdir_All_recursive("$dir/$file");
        else
            unlink("$dir/$file");
    }

    rmdir($dir);
}

function copy_xTransfertFiles_to_Linux($dir) 
{
    $homePath = "muxlab/Desktop";
    
    if (IS_LINUX_OS == true)
        $homePath = "muxlab/Desktop";
    else if (IS_PI_DEBIAN_OS == true)
        $homePath = "pi";
    
    foreach(scandir($dir) as $file)
    {
        if ('.' === $file || '..' === $file)
            continue;
         
        if (!is_dir("$dir/$file"))
        {
            if ($file == "rc.local")
            {
                $res = shell_exec("/home/" .$homePath ."/copyfilesfromweb2 " .$dir ."/" .$file ." /etc" );
                $res = shell_exec("chmod 777 /etc/" .$file );
            }
            else 
            {
                $res = shell_exec("/home/" .$homePath ."/copyfilesfromweb2 " .$dir ."/" .$file ." /home/" .$homePath );
                $res = shell_exec("chmod 777 /home/" .$homePath ."/" .$file );
            }
        }
    }

}

function GetDirectorySize($thePath)
{
    $bytestotal = 0;
    $path = realpath($thePath);
    if($path!==false)
    {
        foreach(new RecursiveIteratorIterator(new RecursiveDirectoryIterator($path, FilesystemIterator::SKIP_DOTS)) as $object)
        {
            $bytestotal += $object->getSize();
        }
    }
    return $bytestotal;
}

function copy_folderContent($src,$dst) 
{
    $dir = opendir($src);

    while(false !== ( $file = readdir($dir)) ) 
    {
        if (( $file != '.' ) && ( $file != '..' )) 
        {
            if ( is_dir($src . '/' . $file) ) 
            {
                // Check if the folder exist before creating it
                if ( !file_exists($dst . '/' . $file) )
                {
                    mkdir($dst . '/' . $file);
                }
                
                copy_folderContent($src . '/' . $file, $dst . '/' . $file);
            }
            else 
            {
                copy($src . '/' . $file, $dst . '/' . $file);
            }
        }
    }
    
    closedir($dir);
}

function getSqlFile($dir)
{
    foreach(scandir($dir) as $file)
    {
        if ('.' === $file || '..' === $file)
            continue;
         
        if (!is_dir("$dir/$file"))
        {
            $extension = end(explode('.', $file));
            
            if ($extension == "sql")
            {
                return $file;
            }
        }
    }

    return "";
}

function getSqlFiles($dir)
{
    $filesFound = array();
     
    foreach(scandir($dir) as $file)
    {
        if ('.' === $file || '..' === $file)
            continue;
         
        if (!is_dir("$dir/$file"))
        {
            $extension = end(explode('.', $file));

            if ($extension == "sql")
            {
                $filesFound[] = $file; 
            }
        }
    }

    return $filesFound;
}

function import_sql_file($host, $user, $pass, $dbname, $sql_file,  $isDeleteAllTablesBefore = false )
{
    if (!file_exists($sql_file)) 
    {
        Logger::getInstance()->lwrite('Info: SoftwareUpdate ===> No sql file to import to databse');
        return false;
    }

    // Connect to MySQL server
    $mysqli = new mysqli($host, $user, $pass, $dbname);

    // Check connection
    if (mysqli_connect_errno())   
    {   
        Logger::getInstance()->lwrite('Error: SoftwareUpdate ===> Failed to connect to MySQL: ' . mysqli_connect_error());
        return false;
    }

    if($isDeleteAllTablesBefore)
    {
        $result = $mysqli->query('SET foreign_key_checks = 0');
        if ($result = $mysqli->query("SHOW TABLES"))
        {
            while($row = $result->fetch_array(MYSQLI_NUM))
            {
                $mysqli->query('DROP TABLE IF EXISTS '.$row[0]);
            }
        }
        $result = $mysqli->query('SET foreign_key_checks = 1');
    }

    $mysqli->query("SET NAMES 'latin1'");
    // Temporary variable, used to store current query
    $templine = '';
    // Read in entire file
    $lines = file($sql_file);
    // Loop through each line
    foreach ($lines as $line)
    {
        // Skip it if it's a comment
        if (substr($line, 0, 2) == '--' || $line == '')
            continue;
        
        // Add this line to the current segment
        $templine .= $line;
        
        // If it has a semicolon at the end, it's the end of the query
        if (substr(trim($line), -1, 1) == ';')
        {
            // Perform the query
            $mysqli->query($templine) or Logger::getInstance()->lwrite('Error: SoftwareUpdate ===> Error performing query: ' . $templine .' err= ' .$mysqli->error); 
            
            // Reset temp variable to empty
            $templine = '';
        }
    }
    
    Logger::getInstance()->lwrite('Tables imported successfully.');

    $mysqli->close();
    
    return true;
}

// ============= END of function declaration ==========================

session_start();

//if ( isset($_SESSION['MyUser']['isAuthenticated']) && ($_SESSION['MyUser']['isAuthenticated'] == true) )
//{
    
if (isset($_FILES["zip_file"]["name"]) && !empty($_FILES["zip_file"]["name"])) 
{
    $message = "There was a problem with the upload. Please try again.";
    
    $filename = $_FILES["zip_file"]["name"];
    $source = $_FILES["zip_file"]["tmp_name"];
    $type = $_FILES["zip_file"]["type"];
    
    $name = explode(".", $filename);

    $accepted_types = array(
        'application/zip',
        'application/x-zip-compressed',
        'multipart/x-zip',
        'application/x-compressed'
    );
    
    foreach ($accepted_types as $mime_type) 
    {
        if ($mime_type == $type) 
        {
            $okay = true;
            break;
        }
    }
    
    $continue = strtolower($name[1]) == 'zip' ? true : false;
    if (! $continue) 
    {
        $message = "The file you are trying to upload is not a .zip file. Please try again.";
    }
    
    /* PHP current path */
    $path = dirname(__FILE__) . '/'; // absolute path to the directory where zipper.php is in
    $filenoext = basename($filename, '.zip'); // absolute path to the directory where zipper.php is in (lowercase)
    $filenoext = basename($filenoext, '.ZIP'); // absolute path to the directory where zipper.php is in (when uppercase)
    
    $targetdir = $path . $filenoext; // target directory
    $targetzip = $path . $filename; // target zip file
    
    $TEST_rootPath = $_SERVER['DOCUMENT_ROOT'];
    $TEST_targetdir = $TEST_rootPath . "/mnc"; // target directory
    $targetzip = $TEST_targetdir . '/' . $filename; // target zip file
    $targetdir = $TEST_targetdir; // target directory
    $TEMP_targetdir = $targetdir . '/xSoftwareUpdateTEMP';
    /* create directory if not exists', otherwise overwrite */
    /* target directory is same as filename without extension */
    
    //mkdir($TEMP_targetdir, 0777);
        
    // Logger::getInstance()->lwrite('DEBUG: SoftwareUpdate ===> $targetdir =' . $targetdir);
    
    /* here it is really happening */
    $expectedProductName = PRODUCT_NAME;
    $expectedProductCode = PRODUCT_CODE;
    $expectedFolderSize = 0;
    
    $receivedProductName = "";
    $receivedProductCode = "";
    $receivedProductRevision = "";
    $receivedSoftVersion = "";
    $receivedDbVersion = "";
    $receivedFolderSize = "";
    $receivedHashValue = "";
    $receivedIsRebootNeeded = "";
    $receivedIsDeleteTables = "";
        
    if (move_uploaded_file($source, $targetzip)) 
    {
        $zip = new ZipArchive();
        $x = $zip->open($targetzip); // open the zip file to extract
        
        if ($x === true) 
        {
            // Get the release notes parameters
            $releaseNote =  $zip->getFromName('release_note_mnc.txt');
            
            if ( ($releaseNote != false) && !empty($releaseNote))
            {
                $releaseNoteLinesArray = explode(PHP_EOL, $releaseNote);
                foreach ($releaseNoteLinesArray as $line) 
                {
                    $keyVakueArray = explode(':', $line);
                    if ($keyVakueArray[0] == "product")
                        $receivedProductName = trim($keyVakueArray[1]);
                    if ($keyVakueArray[0] == "product code")
                        $receivedProductCode = trim($keyVakueArray[1]);
                    if ($keyVakueArray[0] == "product revision")
                        $receivedProductRevision = trim($keyVakueArray[1]);
                    if ($keyVakueArray[0] == "software version")
                        $receivedSoftVersion = trim($keyVakueArray[1]);
                    if ($keyVakueArray[0] == "database version")
                        $receivedDbVersion = trim($keyVakueArray[1]);
                    if ($keyVakueArray[0] == "package")
                        $receivedHashValue = trim($keyVakueArray[1]);
                    if ($keyVakueArray[0] == "reboot")
                        $receivedIsRebootNeeded = trim($keyVakueArray[1]);
                    if ($keyVakueArray[0] == "deltbl")
                        $receivedIsDeleteTables = trim($keyVakueArray[1]);
                }
            }

            // first basic check
            if ( ($receivedProductName == $expectedProductName) && ($receivedProductCode == $expectedProductCode) )
            {
                // Create a temp directory
                mkdir($TEMP_targetdir, 0777);
                
                $zip->extractTo($TEMP_targetdir); // place in the temp directory
                $zip->close();
                
                $expectedFolderSize = GetDirectorySize($TEMP_targetdir);
                
                unlink($targetzip);
                
                // Calculate the Hash to make sure of the validity of this software update package
                $expectedHash = sha1 ( "MUX" .$expectedProductName .$expectedProductCode .$receivedProductRevision .$expectedFolderSize .$receivedSoftVersion .$receivedDbVersion ."LAB");
                
                // $expectedHash = "123";  //  for test purpose
                 // $receivedHashValue = "123";  // for test purpose
                
                if ($expectedHash == $receivedHashValue)
                {
                    // Ok deploy the software update
                    Logger::getInstance()->lwrite('Software package VALIDATED ! Ready to Deploy.');
               
                    // delete old xFileTransfert Folder
                    $exec_result =  shell_exec("chmod 777 " .$_SERVER['DOCUMENT_ROOT'] ."/mnc/" ."xFileTransfert"." -R" );
                    rmdir_All_recursive($_SERVER['DOCUMENT_ROOT'] ."/mnc/" ."xFileTransfert");                    

                    // delete old xDatabase folder
                    $exec_result =  shell_exec("chmod 777 " .$_SERVER['DOCUMENT_ROOT'] ."/mnc/" ."xDatabase"." -R" );
                    rmdir_All_recursive($_SERVER['DOCUMENT_ROOT'] ."/mnc/" ."xDatabase");                                        

                    // Delete first the destination folder content
                    if (is_dir($targetdir))
                        rmdir_recursive($targetdir, $targetdir);
                    
                    // Move temp to real destination folder
                    copy_folderContent($TEMP_targetdir, $targetdir);
                    
                    // Delete entire temp folder
                    rmdir_All_recursive($TEMP_targetdir);
                    
                    // Copy all Linux small software from xFileTransfertFolder
                    copy_xTransfertFiles_to_Linux($TEST_targetdir ."/xFileTransfert");
                    
                    // delete xFileTransfert Folder
                    rmdir_All_recursive($TEST_targetdir ."/xFileTransfert");
                    
                    $message = MESSAGE_SUCCESS;
                    
                    // if present, Import sql file to update database
                    $sqlFileName = getSqlFile($TEST_targetdir ."/xDatabase");
                    if (!empty($sqlFileName))
                    {
                        if ($receivedIsDeleteTables == "1")
                            $isOk = import_sql_file(SQL_SERVER_NAME,  SQL_USER_NAME, SQL_USER_PASSWORD, SQL_DB_NAME, $TEST_targetdir ."/xDatabase/" .$sqlFileName, true);
                        else 
                            $isOk = import_sql_file(SQL_SERVER_NAME,  SQL_USER_NAME, SQL_USER_PASSWORD, SQL_DB_NAME, $TEST_targetdir ."/xDatabase/" .$sqlFileName, false);
                        
                        if ( !$isOk )
                            $message = "The database could not be updated !";
                    }
                    
                    // delete xDatabase folder
                    rmdir_All_recursive($TEST_targetdir ."/xDatabase");
                    
                    // Force the user to re-login
                    // kill session variables
                    session_unset();  // Same as $_SESSION = array(); // reset session array
                    // delete session cookie
                    $params = session_get_cookie_params();
                    setcookie(session_name(), '', time() - 36000, $params["path"], $params["domain"], $params["secure"], $params["httponly"] );
                    // destroy session.
                    session_destroy();
                }
                else 
                {
                    // Delete entire temp folder
                    rmdir_All_recursive($TEMP_targetdir);
                }
                
            }
            else
            {
                $message = "Error: The uploaded file is not valid !";
            }
            
        }
        
    } else 
    {
        $message = "There was a problem with the upload. Please try again.";
    }
    

    if ( $message == MESSAGE_SUCCESS)
        $messageColor = 'green';
    else
        $messageColor = 'red';
}

//}
//else 
//{
//    $message = "You must log on to access this feature !";
//    $messageColor = 'red';
//}
?>
<html>
<head>
		<title>Muxlab Network Controller</title>
		
		<meta charset="utf-8">
        <link rel="icon" type="image/png" sizes="16x16" href="/mnc/Applications/Main/View/images/favicon.ico">
		<link href="/mnc/Applications/Main/View/css/styles.css" type="text/css" rel="stylesheet">
		<link href="/mnc/Applications/Main/View/css/muxlab_utilities.css" type="text/css" rel="stylesheet">
		<script src="/mnc/Applications/Main/View/js/jquery-1.11.1.min.js" type="text/javascript"></script>
		<script src="/mnc/Applications/Main/View/js/muxlab_utilities.js" type="text/javascript"></script>
</head>

<body>

	<div id="overlay"></div>

	<div id="body">
	
				<div id="header">
				<a id="logo" href="/mnc/"><img alt="Muxlab Control Panel" src="/mnc/Applications/Main/View/images/logo.jpg"></a>
				<div data-text="dt_productName" class="localized" id="id_mainProductName">Muxlab Network Controller</div>
				<div id="language"><span data-text="dt_language" class="localized">Language:</span> 
					<select onchange="ui.setLanguage($(this).val());" name="lang">
						<option data-text="english" class="localized" value="en">English</option>
						<option data-text="french" class="localized" value="fr">French</option>
						<option data-text="spanish" class="localized" value="es">Spanish</option>
					</select>
				</div>

			</div>
			
			<div id="nav">
				<a data-text="products" data-minuser="1" class="access_controlled localized" href="javascript:submit_main_simplePost('mainGoHome');" style="display: inline;">Products</a>
				<a data-text="settings" data-minuser="1" class="access_controlled localized" href="javascript:submit_main_simplePost('mainSettings');" style="display: inline;">Settings</a>
				<a data-text="softUpdate" class="localized" href="/mnc/xSoftwareUpdateV202/xSoftwareUpdate.php">Software Update</a>
				<a data-text="help" class="localized" href="javascript:submit_main_simplePost('mainHelp');">Help</a>
			</div>
						
			<div id="content_container">

				<div id="content_center">
						
<br>
<br>
<br>
<div class="center bg_white txt_center">
	<h1 data-text="dt_login" class="localized" style="margin: 10px 0 0 5px">SOFTWARE UPDATE</h1>
	<span data-text="dt_loginWelcome" class="<?php if( isset($message) ) echo $messageColor?> large localized">
	<?php if( isset($message) ) 
	{ 
	    if ( isset($receivedIsRebootNeeded) && ($receivedIsRebootNeeded == "1"))
	       echo "<p>" .$message ."<br> The unit is is rebooting ...</p>";
	    else
	       echo "<p>" .$message ."</p>";
	}
	?></span>
	<br> <br>

	<form enctype="multipart/form-data" method="post" action="">
		<label>Select the software package to install: </label>
		<input type="file" name="zip_file" />
		 <br />
		 <br />  
		<input type="submit" name="submit" value="Upload" onclick="startAnimation()" />
	</form>

	<div class="clear">&nbsp;</div>

</div>
		</div>
		
			</div>
				<div id="divId_animation" style="position:absolute;left:390px;top:325px;z-index: 1;display: none;">
	               <img src="waiting.gif" style="position:absolute; top:-10px; left:-30px;" alt="Please wait..." width="275" height="150"/>
                </div>
			
			<div data-text="copyright" class="localized" id="footer">&copy; 2018 MuxLab Inc. </div>
		
	</div>
	
<script type="text/javascript">
function submit_main_simplePost(pageOrSimpleTask)
{
	<?php
	if ( isset($_SESSION['MyUser']['isAuthenticated']) && ($_SESSION['MyUser']['isAuthenticated'] == true) )
	{
	?>
	
	   var submitForm = document.createElement("FORM");
	   document.body.appendChild(submitForm);
	   submitForm.method = "POST";
	   submitForm.action = location.origin + "/mnc/";

	   var newElementTask = document.createElement("input");
	   newElementTask.setAttribute("name", "p_cmd");
	   newElementTask.setAttribute("type", "hidden");
	   newElementTask.value = pageOrSimpleTask;
	   submitForm.appendChild(newElementTask);

	   var newElementToken = document.createElement("input");
	   newElementToken.setAttribute("name", "p_formToken");
	   newElementToken.setAttribute("type", "hidden");
	   newElementToken.value = "<?php echo $_SESSION['MyContext']['FormToken']; ?>";
	   submitForm.appendChild(newElementToken);

	   submitForm.submit();
   <?php
    }
    else
        echo "location.href = '/mnc/';"; 
	   
	?>
}	
function startAnimation() 
{
	document.getElementById("divId_animation").style.display = "inline";
}
</script>

</body>

</html>
<?php
 if ( isset($receivedIsRebootNeeded) && isset($message) && ($receivedIsRebootNeeded == "1") && ($message == MESSAGE_SUCCESS) )
 {
     if ( PRODUCT_CODE == '500811' )
         $res=shell_exec("sudo shutdown -r now");
     else // Old 500810
        $res=shell_exec("shutdown -r now");
 }
?>